Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/drv/nic/rtl8139/driver.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,4 +34,5 @@
 #include <align.h>
 #include <byteorder.h>
+#include <libarch/ddi.h>
 #include <libarch/barrier.h>
 
Index: uspace/drv/time/cmos-rtc/cmos-rtc.c
===================================================================
--- uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,4 +40,5 @@
 #include <as.h>
 #include <sysinfo.h>
+#include <libarch/ddi.h>
 #include <libarch/barrier.h>
 #include <stdio.h>
@@ -99,6 +100,4 @@
 static time_t uptime_get(void);
 static bool is_battery_ok(rtc_t *rtc);
-static int  rtc_fun_online(ddf_fun_t *fun);
-static int  rtc_fun_offline(ddf_fun_t *fun);
 
 static ddf_dev_ops_t rtc_dev_ops;
@@ -108,6 +107,4 @@
 	.dev_add = rtc_dev_add,
 	.dev_remove = rtc_dev_remove,
-	.fun_online = rtc_fun_online,
-	.fun_offline = rtc_fun_offline,
 };
 
@@ -409,16 +406,10 @@
 	/* Try to normalize the content of the tm structure */
 	time_t r = mktime(t);
-	int result;
-
-	if (r < 0)
-		result = EINVAL;
-	else {
-		rtc->boottime = r - uptime_get();
-		result = EOK;
-	}
+
+	rtc->boottime = r - uptime_get();
 
 	fibril_mutex_unlock(&rtc->mutex);
 
-	return result;
+	return r < 0 ? EINVAL : EOK;
 }
 
@@ -647,10 +638,4 @@
 	fibril_mutex_unlock(&rtc->mutex);
 
-	rc = rtc_fun_offline(rtc->fun);
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed to offline function");
-		return rc;
-	}
-
 	rc = ddf_fun_unbind(rtc->fun);
 	if (rc != EOK) {
@@ -741,25 +726,4 @@
 }
 
-static int
-rtc_fun_online(ddf_fun_t *fun)
-{
-	int rc;
-
-	ddf_msg(LVL_DEBUG, "rtc_fun_online()");
-
-	rc = ddf_fun_online(fun);
-	if (rc == EOK)
-		ddf_fun_add_to_category(fun, "clock");
-
-	return rc;
-}
-
-static int
-rtc_fun_offline(ddf_fun_t *fun)
-{
-	ddf_msg(LVL_DEBUG, "rtc_fun_offline()");
-	return ddf_fun_offline(fun);
-}
-
 int
 main(int argc, char **argv)
Index: uspace/lib/bithenge/src/helenos/common.h
===================================================================
--- uspace/lib/bithenge/src/helenos/common.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/bithenge/src/helenos/common.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -31,5 +31,5 @@
 
 #include <bithenge/os.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <byteorder.h>
 #include <errno.h>
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/Makefile	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -113,7 +113,4 @@
 	generic/iplink.c \
 	generic/iplink_srv.c \
-	generic/ieee_double.c \
-	generic/power_of_ten.c \
-	generic/double_to_str.c \
 	generic/malloc.c \
 	generic/sysinfo.c \
@@ -137,11 +134,9 @@
 	generic/net/socket_client.c \
 	generic/net/socket_parse.c \
-	generic/stack.c \
 	generic/stacktrace.c \
 	generic/arg_parse.c \
 	generic/sort.c \
 	generic/stats.c \
-	generic/assert.c \
-	generic/pio_trace.c
+	generic/assert.c
 
 ifeq ($(CONFIG_RTLD),y)
Index: uspace/lib/c/arch/abs32le/include/libarch/atomic.h
===================================================================
--- uspace/lib/c/arch/abs32le/include/libarch/atomic.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/abs32le/include/libarch/atomic.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 #define LIBC_abs32le_ATOMIC_H_
 
-#include <stdbool.h>
+#include <bool.h>
 
 #define LIBC_ARCH_ATOMIC_H_
Index: uspace/lib/c/arch/abs32le/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/abs32le/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/abs32le/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,30 +36,30 @@
 #include <libarch/types.h>
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t v)
+static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t v)
+static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t v)
+static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
 	*port = v;
 }
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	return *port;
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	return *port;
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	return *port;
Index: uspace/lib/c/arch/abs32le/src/entryjmp.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/entryjmp.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/abs32le/src/entryjmp.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -30,5 +30,5 @@
  */
 
-#include <stdbool.h>
+#include <bool.h>
 #include <entry_point.h>
 
Index: uspace/lib/c/arch/abs32le/src/fibril.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/fibril.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/abs32le/src/fibril.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -31,5 +31,5 @@
 
 #include <fibril.h>
-#include <stdbool.h>
+#include <bool.h>
 
 int context_save(context_t *ctx)
Index: uspace/lib/c/arch/abs32le/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/abs32le/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -32,5 +32,5 @@
 #include <sys/types.h>
 #include <unistd.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <stacktrace.h>
 
Index: uspace/lib/c/arch/abs32le/src/tls.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/abs32le/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,10 +34,10 @@
 #include <unistd.h>
 
-tcb_t * tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_2(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_2(tcb, size);
Index: uspace/lib/c/arch/amd64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/amd64/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/amd64/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #include <stacktrace.h>
Index: uspace/lib/c/arch/amd64/src/tls.c
===================================================================
--- uspace/lib/c/arch/amd64/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/amd64/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,10 +38,10 @@
 #include <sys/types.h>
 
-tcb_t *tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_2(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_2(tcb, size);
Index: uspace/lib/c/arch/arm32/Makefile.common
===================================================================
--- uspace/lib/c/arch/arm32/Makefile.common	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/arm32/Makefile.common	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -28,11 +28,6 @@
 #
 
-GCC_CFLAGS += -ffixed-r9 -mtp=soft -fno-omit-frame-pointer -mapcs-frame -march=$(subst _,-,$(PROCESSOR_ARCH))
-
-ifeq ($(CONFIG_FPU),y)
-GCC_CFLAGS += -mfloat-abi=hard
-else
 BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
-endif
+GCC_CFLAGS += -ffixed-r9 -mtp=soft -fno-omit-frame-pointer -march=armv4 -mapcs-frame
 
 ENDIANESS = LE
Index: uspace/lib/c/arch/arm32/include/libarch/atomic.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/atomic.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/arm32/include/libarch/atomic.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -41,5 +41,5 @@
 
 #include <atomicdflt.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/types.h>
 
Index: uspace/lib/c/arch/arm32/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/arm32/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,30 +37,30 @@
 #include <libarch/types.h>
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t v)
+static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t v)
+static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t v)
+static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
 	*port = v;
 }
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	return *port;
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	return *port;
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	return *port;
Index: uspace/lib/c/arch/arm32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/arm32/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/arm32/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #include <stacktrace.h>
Index: uspace/lib/c/arch/arm32/src/tls.c
===================================================================
--- uspace/lib/c/arch/arm32/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/arm32/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,10 +38,10 @@
 #include <sys/types.h>
 
-tcb_t *tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_1(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_1(tcb, size);
Index: uspace/lib/c/arch/ia32/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ia32/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 #define IO_SPACE_BOUNDARY  ((void *) (64 * 1024))
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	if (port < (ioport8_t *) IO_SPACE_BOUNDARY) {
@@ -55,5 +55,5 @@
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	if (port < (ioport16_t *) IO_SPACE_BOUNDARY) {
@@ -71,5 +71,5 @@
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	if (port < (ioport32_t *) IO_SPACE_BOUNDARY) {
@@ -87,5 +87,5 @@
 }
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t val)
+static inline void pio_write_8(ioport8_t *port, uint8_t val)
 {
 	if (port < (ioport8_t *) IO_SPACE_BOUNDARY) {
@@ -98,5 +98,5 @@
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t val)
+static inline void pio_write_16(ioport16_t *port, uint16_t val)
 {
 	if (port < (ioport16_t *) IO_SPACE_BOUNDARY) {
@@ -109,5 +109,5 @@
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t val)
+static inline void pio_write_32(ioport32_t *port, uint32_t val)
 {
 	if (port < (ioport32_t *) IO_SPACE_BOUNDARY) {
Index: uspace/lib/c/arch/ia32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/ia32/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ia32/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,5 +37,5 @@
 #include <libarch/config.h>
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <stacktrace.h>
 
Index: uspace/lib/c/arch/ia32/src/tls.c
===================================================================
--- uspace/lib/c/arch/ia32/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ia32/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,10 +39,10 @@
 #include <align.h>
 
-tcb_t *tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_2(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_2(tcb, size);
Index: uspace/lib/c/arch/ia64/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ia64/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -50,5 +50,5 @@
 	    (ia64_iospace_address = get_ia64_iospace_address()))
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t v)
+static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
 	if (port < (ioport8_t *) IO_SPACE_BOUNDARY) {
@@ -65,5 +65,5 @@
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t v)
+static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
 	if (port < (ioport16_t *) IO_SPACE_BOUNDARY) {
@@ -80,5 +80,5 @@
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t v)
+static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
 	if (port < (ioport32_t *) IO_SPACE_BOUNDARY) {
@@ -95,5 +95,5 @@
 }
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	uint8_t v;
@@ -115,5 +115,5 @@
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	uint16_t v;
@@ -135,5 +135,5 @@
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	uint32_t v;
Index: uspace/lib/c/arch/ia64/src/ddi.c
===================================================================
--- uspace/lib/c/arch/ia64/src/ddi.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ia64/src/ddi.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -1,29 +1,2 @@
-/*
- * Copyright (c) 2006 Martin Decky
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
 #include <libarch/ddi.h>
 #include <sysinfo.h>
@@ -39,2 +12,3 @@
 	return addr;
 }
+
Index: uspace/lib/c/arch/ia64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/ia64/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ia64/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 
Index: uspace/lib/c/arch/ia64/src/tls.c
===================================================================
--- uspace/lib/c/arch/ia64/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ia64/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,10 +38,10 @@
 #include <malloc.h>
 
-tcb_t *tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_1(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_1(tcb, size);
Index: uspace/lib/c/arch/mips32/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/mips32/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/mips32/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,30 +37,30 @@
 #include <libarch/types.h>
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t v)
+static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t v)
+static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t v)
+static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
 	*port = v;
 }
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	return *port;
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	return *port;
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	return *port;
Index: uspace/lib/c/arch/mips32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/mips32/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/mips32/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 
Index: uspace/lib/c/arch/mips32/src/tls.c
===================================================================
--- uspace/lib/c/arch/mips32/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/mips32/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,10 +37,10 @@
 #include <sys/types.h>
 
-tcb_t * tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_1(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_1(tcb, size);
Index: uspace/lib/c/arch/mips64/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/mips64/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/mips64/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,30 +37,30 @@
 #include <libarch/types.h>
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t v)
+static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t v)
+static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t v)
+static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
 	*port = v;
 }
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	return *port;
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	return *port;
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	return *port;
Index: uspace/lib/c/arch/mips64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/mips64/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/mips64/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 
Index: uspace/lib/c/arch/mips64/src/tls.c
===================================================================
--- uspace/lib/c/arch/mips64/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/mips64/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,10 +37,10 @@
 #include <sys/types.h>
 
-tcb_t *tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_1(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_1(tcb, size);
Index: uspace/lib/c/arch/ppc32/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ppc32/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,30 +37,30 @@
 #include <libarch/types.h>
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t v)
+static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t v)
+static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
 	*port = v;
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t v)
+static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
 	*port = v;
 }
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	return *port;
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	return *port;
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	return *port;
Index: uspace/lib/c/arch/ppc32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/ppc32/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ppc32/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #include <stacktrace.h>
Index: uspace/lib/c/arch/ppc32/src/tls.c
===================================================================
--- uspace/lib/c/arch/ppc32/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/ppc32/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,10 +36,10 @@
 #include <sys/types.h>
 
-tcb_t *tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_1(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_1(tcb, size);
Index: uspace/lib/c/arch/sparc64/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/sparc64/include/libarch/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -45,5 +45,5 @@
 }
 
-static inline void arch_pio_write_8(ioport8_t *port, uint8_t v)
+static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
 	*port = v;
@@ -51,5 +51,5 @@
 }
 
-static inline void arch_pio_write_16(ioport16_t *port, uint16_t v)
+static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
 	*port = v;
@@ -57,5 +57,5 @@
 }
 
-static inline void arch_pio_write_32(ioport32_t *port, uint32_t v)
+static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
 	*port = v;
@@ -63,5 +63,5 @@
 }
 
-static inline uint8_t arch_pio_read_8(const ioport8_t *port)
+static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	uint8_t rv;
@@ -73,5 +73,5 @@
 }
 
-static inline uint16_t arch_pio_read_16(const ioport16_t *port)
+static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	uint16_t rv;
@@ -83,5 +83,5 @@
 }
 
-static inline uint32_t arch_pio_read_32(const ioport32_t *port)
+static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	uint32_t rv;
Index: uspace/lib/c/arch/sparc64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/sparc64/src/stacktrace.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/sparc64/src/stacktrace.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,5 +35,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <libarch/stack.h>
 #include <errno.h>
Index: uspace/lib/c/arch/sparc64/src/tls.c
===================================================================
--- uspace/lib/c/arch/sparc64/src/tls.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/arch/sparc64/src/tls.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,10 +38,10 @@
 #include <sys/types.h>
 
-tcb_t *tls_alloc_arch(void **data, size_t size)
+tcb_t * __alloc_tls(void **data, size_t size)
 {
 	return tls_alloc_variant_2(data, size);
 }
 
-void tls_free_arch(tcb_t *tcb, size_t size)
+void __free_tls_arch(tcb_t *tcb, size_t size)
 {
 	tls_free_variant_2(tcb, size);
Index: uspace/lib/c/generic/adt/list.c
===================================================================
--- uspace/lib/c/generic/adt/list.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/generic/adt/list.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 
 #include <adt/list.h>
-#include <stdbool.h>
+#include <bool.h>
 
 /** Check for membership
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/generic/async.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -109,5 +109,5 @@
 #include <sys/time.h>
 #include <libarch/barrier.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <malloc.h>
 #include <mem.h>
Index: uspace/lib/c/generic/ddi.c
===================================================================
--- uspace/lib/c/generic/ddi.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/generic/ddi.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,7 +34,5 @@
 
 #include <assert.h>
-#include <atomic.h>
 #include <unistd.h>
-#include <stdio.h>
 #include <errno.h>
 #include <sys/types.h>
@@ -48,5 +46,4 @@
 #include <libarch/config.h>
 #include "private/libc.h"
-
 
 /** Return unique device number.
@@ -123,11 +120,11 @@
  *
  */
-static int iospace_enable(task_id_t id, void *ioaddr, size_t size)
+int iospace_enable(task_id_t id, void *ioaddr, unsigned long size)
 {
-	const ddi_ioarg_t arg = {
-		.task_id = id,
-		.ioaddr = ioaddr,
-		.size = size
-	};
+	ddi_ioarg_t arg;
+	
+	arg.task_id = id;
+	arg.ioaddr = ioaddr;
+	arg.size = size;
 	
 	return __SYSCALL1(SYS_IOSPACE_ENABLE, (sysarg_t) &arg);
@@ -139,5 +136,5 @@
  * @param size     Size of the I/O region.
  * @param virt     Virtual address for application's
- *                 PIO operations. Can be NULL for PMIO.
+ *                 PIO operations.
  *
  * @return EOK on success.
@@ -149,14 +146,9 @@
 #ifdef IO_SPACE_BOUNDARY
 	if (pio_addr < IO_SPACE_BOUNDARY) {
-		if (virt)
-			*virt = pio_addr;
+		*virt = pio_addr;
 		return iospace_enable(task_get_id(), pio_addr, size);
 	}
-#else
-	(void) iospace_enable;
 #endif
-	if (!virt)
-		return EINVAL;
-
+	
 	void *phys_frame =
 	    (void *) ALIGN_DOWN((uintptr_t) pio_addr, PAGE_SIZE);
@@ -172,43 +164,4 @@
 	*virt = virt_page + offset;
 	return EOK;
-}
-
-void pio_write_8(ioport8_t *reg, uint8_t val)
-{
-	pio_trace_log(reg, val, true);
-	arch_pio_write_8(reg, val);
-}
-
-void pio_write_16(ioport16_t *reg, uint16_t val)
-{
-	pio_trace_log(reg, val, true);
-	arch_pio_write_16(reg, val);
-}
-
-void pio_write_32(ioport32_t *reg, uint32_t val)
-{
-	pio_trace_log(reg, val, true);
-	arch_pio_write_32(reg, val);
-}
-
-uint8_t pio_read_8(const ioport8_t *reg)
-{
-	const uint8_t val = arch_pio_read_8(reg);
-	pio_trace_log(reg, val, false);
-	return val;
-}
-
-uint16_t pio_read_16(const ioport16_t *reg)
-{
-	const uint16_t val = arch_pio_read_16(reg);
-	pio_trace_log(reg, val, false);
-	return val;
-}
-
-uint32_t pio_read_32(const ioport32_t *reg)
-{
-	const uint32_t val = arch_pio_read_32(reg);
-	pio_trace_log(reg, val, false);
-	return val;
 }
 
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/generic/devman.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -45,5 +45,5 @@
 #include <errno.h>
 #include <malloc.h>
-#include <stdbool.h>
+#include <bool.h>
 
 static FIBRIL_MUTEX_INITIALIZE(devman_driver_block_mutex);
